import * as Discord from 'discord.js';
import {log} from '../core/utils';
import {PAGE_NAME_REGEXP} from '../models/wikidot-page';
import transferPage from './pages-transferer';

const vega = new Discord.Client();
const token = process.env.DISCORD_BOT_TOKEN;

const COMMAND_REGEXP = /^\/(\w+)/;
const DEV_CHANNEL_ID = '402913158127288321';
const STAFF_CHANNEL_ID = '363739114895441921';

vega.on('ready', () => {
    log('VEGA is ready');
});

vega.on('message', (message) => {
    const match = COMMAND_REGEXP.exec(message.content);
    const command = match && match[1];
    const content = message.content.split(' ').slice(1).join(' ');

    switch (command) {
        case 'ping':
            message.channel.send('pong');
            break;
        case 'beep':
            message.channel.send('boop');
            break;
        case 'transfer':
            const allowedChannel = [DEV_CHANNEL_ID, STAFF_CHANNEL_ID].includes(message.channel.id);
            const pageNameMatch = PAGE_NAME_REGEXP.exec(content);
            const pageName = pageNameMatch && pageNameMatch[1];
            if (allowedChannel && pageName) {
                transferPage(pageName.toLowerCase(), message);
            }
            break;
    }
});

vega.login(token);
