"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Discord = require("discord.js");
const utils_1 = require("../core/utils");
const wikidot_page_1 = require("../models/wikidot-page");
const pages_transferer_1 = require("./pages-transferer");
const vega = new Discord.Client();
const token = process.env.DISCORD_BOT_TOKEN;
const COMMAND_REGEXP = /^\/(\w+)/;
const DEV_CHANNEL_ID = '402913158127288321';
const STAFF_CHANNEL_ID = '363739114895441921';
vega.on('ready', () => {
    utils_1.log('VEGA is ready');
});
vega.on('message', (message) => {
    const match = COMMAND_REGEXP.exec(message.content);
    const command = match && match[1];
    const content = message.content.split(' ').slice(1).join(' ');
    switch (command) {
        case 'ping':
            message.channel.send('pong');
            break;
        case 'beep':
            message.channel.send('boop');
            break;
        case 'transfer':
            const allowedChannel = [DEV_CHANNEL_ID, STAFF_CHANNEL_ID].includes(message.channel.id);
            const pageNameMatch = wikidot_page_1.PAGE_NAME_REGEXP.exec(content);
            const pageName = pageNameMatch && pageNameMatch[1];
            if (allowedChannel && pageName) {
                pages_transferer_1.default(pageName.toLowerCase(), message);
            }
            break;
    }
});
vega.login(token);
//# sourceMappingURL=vega.js.map